/*
 * $Id: send.prg 18770 2013-01-23 00:05:19Z vszakats $
 */

/*
 * Copyright 2009-2010 Viktor Szakats (harbour syenar.net)
 * www - http://www.harbour-project.org
 */
# include "hmg.ch"
 

 
function sendsms( cPort )
   default cPort := 'COM7'
//   x := sms_Send( cPort, "9443146502", "test msg", .T. )
   x := sms_Send( cPort, "9443146502", "HMG Test SMS.", .T. )
   if valtype( x ) == "N"
      msginfo( str( x ) )
   endif   

   RETURN


   
function sms_send( cPort, cPhone, cMsg, lNotify )
   local nSize, cReceive
   private s_nHandle := INIT_PORT( cPort, 9600, 8, 0, 1, 64 )
   private s_lConnected := .f.
//   private crlf := chr( 13 ) + chr( 10 )

   if s_nHandle > 0
      msginfo( 'Init Successful' )
      s_lConnected := .t.
   else
      msginfo( 'Init Failed' )
      return nil
   endif
   
   if isworking( s_nHandle )
      _send_at( "ATE0V1Q0" + Chr( 13 ) )
   endif
   if isworking( s_nHandle )
      _send_at( "AT+CMGF=1" + Chr( 13 ) )
   endif
   if isworking( s_nHandle )
      _init_msg( 'AT+CMGS="' + cPhone + '"' + Chr( 13 ) )
   endif
   if isworking( s_nHandle )
      _send_smsmsg( StrTran( cMsg, Chr( 13 ) ) + Chr( 26 ) )
   endif
   if isworking( s_nHandle )
      _send_at( "AT" + Chr( 13 ) )
   endif
   _conn_close()   
return nil      


function _conn_close
   UNINT_PORT( s_nHandle )      
return nil   

function _send_at( cMessage )
   if outchr( s_nHandle, cMessage )
//      msginfo( 'Sent->' + cMessage ) 
   else
      return .f.
   endif
   nSize := inbufsize( s_nHandle )
   cReceive := space( nSize )
   nReceive := inchr( s_nHandle, nSize, @cReceive )
   aLines := _comm_StrConvert( cReceive )
   if len( aLines ) > 0
      cResponse := aLines[ len( aLines ) ] 
      msginfo( cResponse )
   endif   
   if .not. cResponse == 'OK'
      return .f.
   endif
   return .t.
   
   
&& STATIC FUNCTION port_send( h, s )
   && RETURN hb_comSend( h, s )

&& STATIC FUNCTION port_rece( h, n, t )

   && LOCAL cString

   && hb_default( @n, 64 )
   && hb_default( @t, 500 )

   && cString := Space( n )

   && hb_comRecv( h, @cString,, t )

   && RETURN cString

&& FUNCTION sms_Send( cPort, cPhoneNo, cText, lNotification, cPIN )

   && LOCAL smsctx
   && LOCAL nRetVal
   && IF ! Empty( smsctx := smsctx_New( cPort ) )
      && smsctx_PIN( smsctx, cPIN )
      && nRetVal := smsctx_Send( smsctx, cPhoneNo, cText, lNotification )
      && msginfo( iif( smsctx_Close( smsctx ), 'Closed', 'Not Closed' ) )
   && ELSE
      && nRetVal := -99
   && ENDIF

   && RETURN nRetVal

&& FUNCTION sms_ReceiveAll( cPort, cPIN )

   && LOCAL smsctx
   && LOCAL aRetVal

   && IF ! Empty( smsctx := smsctx_New( cPort ) )
      && smsctx_PIN( smsctx, cPIN )
      && aRetVal := smsctx_Receive( smsctx )
      && smsctx_Close( smsctx )
   && ELSE
      && aRetVal := NIL
   && ENDIF

   && RETURN aRetVal

&& /* --------------------- */

&& #define _SMSCTX_xHnd          1
&& #define _SMSCTX_cPIN          2
&& #define _SMSCTX_cPrevName     3
&& #define _SMSCTX_MAX_          3

&& FUNCTION smsctx_New( xPort )

   && LOCAL smsctx[ _SMSCTX_MAX_ ]

   && IF HB_ISNUMERIC( xPort )
      && smsctx[ _SMSCTX_xHnd ] := xPort
      && smsctx[ _SMSCTX_cPrevName ] := NIL
   && ELSEIF HB_ISSTRING( xPort )
      && smsctx[ _SMSCTX_xHnd ] := 1
      && smsctx[ _SMSCTX_cPrevName ] := hb_comGetDevice( smsctx[ _SMSCTX_xHnd ] )
      && hb_comSetDevice( smsctx[ _SMSCTX_xHnd ], xPort )
   && ELSE
      && smsctx[ _SMSCTX_xHnd ] := NIL
   && ENDIF

   && IF smsctx[ _SMSCTX_xHnd ] != NIL
      && IF hb_comOpen( smsctx[ _SMSCTX_xHnd ] )
         && IF hb_comInit( smsctx[ _SMSCTX_xHnd ], 9600, "N", 8, 1 )
            && RETURN smsctx
         && ELSE
            && hb_comClose( smsctx[ _SMSCTX_xHnd ] )
         && ENDIF
      && ENDIF
   && ENDIF

   && RETURN NIL

&& FUNCTION smsctx_Close( smsctx )

   && IF ! HB_ISARRAY( smsctx ) .OR. Len( smsctx ) != _SMSCTX_MAX_
      && RETURN .F.
   && ENDIF

   && IF ! hb_comClose( smsctx[ _SMSCTX_xHnd ] )
      && RETURN .F.
   && ENDIF

   && /* Restore com port name */
   && IF smsctx[ _SMSCTX_cPrevName ] != NIL
      && hb_comSetDevice( smsctx[ _SMSCTX_xHnd ], smsctx[ _SMSCTX_cPrevName ] )
   && ENDIF

   && RETURN .T.

&& FUNCTION smsctx_Send( smsctx, cPhoneNo, cText, lNotification )

   && LOCAL tmp

   && IF ! HB_ISARRAY( smsctx ) .OR. Len( smsctx ) != _SMSCTX_MAX_
      && RETURN -1
   && ENDIF

   && port_send( smsctx[ _SMSCTX_xHnd ], "ATE0V1Q0" + Chr( 13 ) )
   && cResponse := port_rece( smsctx[ _SMSCTX_xHnd ] )
   && msginfo( str( len( cResponse ) ) )
   && msginfo( str( len( alltrim( cResponse ) ) ) )
   && msginfo( alltrim( cResponse ) )
   && IF StripCRLF( cResponse ) == 'OK'
      && port_send( smsctx[ _SMSCTX_xHnd ], "AT+CMGF=1" + Chr( 13 ) )
      && cResponse := port_rece( smsctx[ _SMSCTX_xHnd ] )
      && if StripCRLF( cResponse ) == 'OK'
         && IF ! Empty( smsctx[ _SMSCTX_cPIN ] )
            && port_send( smsctx[ _SMSCTX_xHnd ], 'AT+CPIN="' + smsctx[ at_SMSCTX_cPIN ] + '"' + Chr( 13 ) )
            && IF !( StripCRLF( port_rece( smsctx[ _SMSCTX_xHnd ] ) ) == "OK" )
               && RETURN -5
            && ENDIF
         && ENDIF

         && port_send( smsctx[ _SMSCTX_xHnd ], "AT+CMGF=1" + Chr( 13 ) )
         && IF StripCRLF( port_rece( smsctx[ _SMSCTX_xHnd ] ) ) == "OK"

            && IF HB_ISLOGICAL( lNotification )
               && port_send( smsctx[ _SMSCTX_xHnd ], "AT+CSMP?" + Chr( 13 ) )
               && tmp := GetLines( port_rece( smsctx[ _SMSCTX_xHnd ] ) )
               && IF Len( tmp ) < 2
                  && RETURN -6
               && ENDIF
               && IF !( ATail( tmp ) == "OK" )
                  && RETURN -7
               && ENDIF
               && IF !( Left( tmp[ 1 ], Len( "+CSMP: " ) ) == "+CSMP: " )
                  && RETURN -8
               && ENDIF
               && tmp := GetList( SubStr( tmp[ 1 ], Len( "+CSMP: " ) + 1 ) )
               && IF Len( tmp ) > 1
                  && IF lNotification
                     && tmp[ 1 ] := hb_ntos( hb_bitSet( Val( tmp[ 1 ] ), 5 ) )
                  && ELSE
                     && tmp[ 1 ] := hb_ntos( hb_bitReset( Val( tmp[ 1 ] ), 5 ) )
                  && ENDIF
                  && port_send( smsctx[ _SMSCTX_xHnd ], "AT+CSMP=" + MakeList( tmp ) + Chr( 13 ) )
                  && IF !( StripCRLF( port_rece( smsctx[ _SMSCTX_xHnd ] ) ) == "OK" )
                     && RETURN -9
                  && ENDIF
               && ENDIF
            && ENDIF

            && port_send( smsctx[ _SMSCTX_xHnd ], 'AT+CMGS="' + cPhoneNo + '"' + Chr( 13 ) )
            && cResponse := StripCRLF( port_rece( smsctx[ _SMSCTX_xHnd ] ) )
            && if valtype( cResponse ) == "C"
               && cStr := ''
               && for i := 1 to len( cResponse )
                  && cStr := cStr + alltrim( str( asc( substr( cResponse, i, 1 ) ) ) )
               && next i
               && msginfo( cStr )
&& //               msginfo( 'Response: ' + cResponse )
            && endif
            && IF cResponse == "> "
               && port_send( smsctx[ _SMSCTX_xHnd ], StrTran( cText, Chr( 13 ) ) + Chr( 26 ) )
               && tmp := StripCRLF( port_rece( smsctx[ _SMSCTX_xHnd ] ) )
               && IF Left( tmp, Len( "+CMGS: " ) ) == "+CMGS: "
                  && RETURN 0
               && ELSE
                  && RETURN -10
               && ENDIF
            && ELSE
               && RETURN -11
            && ENDIF
         && ELSE
            && RETURN -12
         && ENDIF
      && ELSE
         && RETURN -4
      && ENDIF
   && ELSE
      && RETURN -3
   && ENDIF

   && RETURN -2

&& FUNCTION smsctx_Receive( smsctx )

   && IF ! HB_ISARRAY( smsctx ) .OR. Len( smsctx ) != _SMSCTX_MAX_
      && RETURN NIL
   && ENDIF

   && // ...

   && RETURN {}

&& FUNCTION smsctx_PIN( smsctx, cPIN )

   && LOCAL cOldValue

   && IF ! HB_ISARRAY( smsctx ) .OR. Len( smsctx ) != _SMSCTX_MAX_
      && RETURN NIL
   && ENDIF

   && cOldValue := smsctx[ _SMSCTX_cPIN ]
   && IF cPIN == NIL .OR. ( HB_ISSTRING( cPIN ) .AND. Len( cPIN ) == 4 )
      && smsctx[ _SMSCTX_cPIN ] := cPIN
   && ENDIF

   && RETURN cOldValue


&& STATIC FUNCTION StripCR( cString )
   && RETURN StrTran( cString, Chr( 13 ) )


&& STATIC FUNCTION StripCRLF( cString )
   && local cOut := cString
   && cOut := strTran( cOut, Chr( 13 ) + Chr( 10 ) )
   && cOut := strTran( cOut, Chr( 32 ) )
   && RETURN cOut

&& STATIC FUNCTION IsOK( cString )

   && LOCAL tmp := GetLines( cString )

   && RETURN ! Empty( tmp ) .AND. ATail( tmp ) == "OK"

&& STATIC FUNCTION GetLines( cString )

   && LOCAL aLine := {}
   && LOCAL tmp

   && IF Left( cString, 2 ) == Chr( 13 ) + Chr( 10 )
      && cString := SubStr( cString, Len( Chr( 13 ) + Chr( 10 ) ) + 1 )
   && ENDIF
   && IF Right( cString, 2 ) == Chr( 13 ) + Chr( 10 )
      && cString := hb_StrShrink( cString, Len( Chr( 13 ) + Chr( 10 ) ) )
   && ENDIF

   && FOR EACH tmp IN hb_ATokens( StrTran( cString, Chr( 13 ) ), Chr( 10 ) )
      && AAdd( aLine, tmp )
   && NEXT

   && RETURN aLine

&& STATIC FUNCTION GetList( cString )

   && LOCAL aList := {}
   && LOCAL tmp

   && FOR EACH tmp IN hb_ATokens( cString, "," )
      && AAdd( aList, tmp )
   && NEXT

   && RETURN aList

&& STATIC FUNCTION MakeList( aList )

   && LOCAL cString := ""
   && LOCAL tmp

   && FOR EACH tmp IN aList
      && cString += tmp + ","
   && NEXT

   && RETURN hb_StrShrink( cString, Len( "," ) )
   